<template>
    <div>
        <app-layout>
            <template #header>Shows</template>
            <panel>
                <button @click="newShowModalOpen = true" class="mt-4 ml-6 whitespace-no-wrap items-center px-4 py-2 border border-transparent text-base leading-6 font-medium rounded-md text-white bg-green-500 hover:bg-green-400 focus:outline-none focus:border-green-600 focus:shadow-outline-green active:bg-green-600 transition ease-in-out duration-150">
                    New Show
                </button>
                <div class="p-6 sm:px-20">
                    <input-error :message="newform.error('code')" class="mt-2" />
                    <input-error :message="newform.error('description')" class="mt-2" />
                    <table class="table-auto" v-if="shows.length > 0">
                        <thead>
                            <tr>
                                <th class="px-4 py-2">Name</th>
                                <th></th>
                            </tr>
                        </thead>
                        <tbody>
                            <tr v-for="show in shows" :key="show.id" class="hover:bg-yellow-100 dark:hover:bg-yellow-900 transition duration-500 ease-in-out" @dblclick="$inertia.get('/shows/' + show.id)">
                                <td class="border dark:border-gray-800 px-4 py-2">{{show.name}}</td>
                                <td class="border-t border-b dark:border-gray-900 px-4 py-2">
                                    <inertia-link :href="'/shows/' + show.id" class='text-gray-500 hover:text-gray-700 hover:border-gray-300 focus:outline-none focus:text-gray-700 focus:border-gray-300 transition duration-150 ease-in-out' title="Edit"><fa-icon icon="pencil-alt" /></inertia-link>
                                    <a title="Deploy"><fa-icon class="ml-2 text-blue-600 hover:text-blue-700 cursor-pointer transition duration-150 ease-in-out" icon="upload"/></a>
                                    <a title="Delete Show" @click="deleteShow(show.id)"><fa-icon class=" ml-2 text-red-700 hover:text-red-800 cursor-pointer transition duration-150 ease-in-out" icon="trash"/></a>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                    <div v-else>
                        No Shows
                    </div>
                </div>
            </panel>
        </app-layout>
        <dialog-modal :show="newShowModalOpen" @close="newShowModalOpen = false">
            <template #title>New Show</template>
            <div class="mb-4">
                <x-label class="mb-2">Name</x-label>
                <x-input v-model="newform.name" placeholder="My Show" class="w-full py-2 px-3"/>
            </div>
            <div class="mb-4">
                <x-label class="mb-2">Description</x-label>
                <x-input type="textarea" v-model="newform.description" class="w-full py-2 px-3"/>
            </div>
            <template #footer>
                <danger-button @click.native.prevent="newShowModalOpen = false">Cancel</danger-button>
                <x-button class="ml-2" @click.native.prevent="createShow">Create</x-button>
            </template>
        </dialog-modal>
    </div>
</template>

<script>
    export default {
        props: {
            shows: Array,
        },
        data(){
            return {
                newShowModalOpen: false,
                newform: this.$inertia.form({
                    name: this.name,
                    description: this.description,
                }, {
                    bag: 'createShow',
                    resetOnSuccess: true,
                }),
            }
        },
        methods: {
            createShow(){
                this.newform.post('/shows',{
                    preserveScroll: true,
                });
                this.newShowModalOpen = false;
            },
            deleteShow(id){
                this.$inertia.delete('/shows/'+id, {
                    preserveState: true,
                    preserveScroll: true,
                    onSuccess(){
                        this.shows = this.shows.filter(function(group){
                            return group.id !== id;
                        });
                    },
                });
            },
        },
    }
</script>
